<template>
  <div class="Search">
    <h4 v-if="this.projectDisplayName !== ''" style="text-align: left">
      {{ $t("searchIn") + this.projectDisplayName }}:
    </h4>
    <h4 v-else style="text-align: left">{{ $t("search") }}:</h4>
    <b-container>
      <div>
        <b-row>
          <b-input-group>
            <b-input
              v-model="searchWord"
              @keydown.enter.prevent.self="search"
              type="text"
            ></b-input>
            <b-input-group-append>
              <b-button id="startSearchButton" :disabled="!searchWord" @click.prevent="search">{{
                $t("search")
              }}</b-button>
            </b-input-group-append>
          </b-input-group>
        </b-row>
        <b-row
          ><h5 style="text-align: left">{{ $t("project") }}</h5></b-row
        >
        <span
          v-for="(project, index) in results['Projects']"
          :key="`${index}-${project.id}`"
        >
          <b-row>
            <b-col sm="12">
              <a :href="getExternalProjectLink(project.slug)">{{
                project.displayName
              }}</a>
            </b-col>
          </b-row>
        </span>
        <b-row v-if="results['Projects'].length === 0">
          <b-col sm="12">
            {{ $t("noHits") }}
          </b-col>
        </b-row>
        <b-row
          ><h5 style="text-align: left">{{ $t("subproject") }}</h5></b-row
        >
        <span
          v-for="(subproject, index) in results['SubProjects']"
          :key="`${index}-${subproject.id}`"
        >
          <b-row>
            <b-col sm="12">
              <a :href="getExternalProjectLink(subproject.slug)">{{
                subproject.displayName
              }}</a>
            </b-col>
          </b-row>
        </span>
        <b-row v-if="results['SubProjects'].length === 0">
          <b-col sm="12">
            {{ $t("noHits") }}
          </b-col>
        </b-row>
        <b-row
          ><h5 style="text-align: left">{{ $t("resource") }}</h5></b-row
        >
        <span
          v-for="(resource, index) in results['Resources']"
          :key="`${index}-${resource.id}`"
        >
          <b-row>
            <b-col sm="12">
              {{ resource.displayName }}
              <a
                :href="
                  getExternalProjectLink(resource.slug, 'CreateResource', {
                    resource_id: resource.id,
                  })
                "
                >{{ $t("editResource") }}</a
              >
              /
              <a
                :href="
                  getExternalProjectLink(resource.slug, 'ViewResource', {
                    resource_id: resource.id,
                  })
                "
                >{{ $t("viewResource") }}</a
              >
            </b-col>
          </b-row>
        </span>
        <b-row v-if="results['Resources'].length === 0">
          <b-col sm="12">
            {{ $t("noHits") }}
          </b-col>
        </b-row>
        <b-row
          ><h5 style="text-align: left">{{ $t("file") }}</h5></b-row
        >
        <span
          v-for="(file, index) in results['Files']"
          :key="`${index}-${file.id}`"
        >
          <b-row>
            <b-col sm="12">
              <a v-if="file.slug"
                :href="
                  getExternalProjectLink(file.slug, 'ViewResource', {
                    resource_id: file.id,
                  })
                "
                >{{ file.displayName }}</a
              >
              <div v-else>{{ file.displayName }}</div>
            </b-col>
          </b-row>
        </span>
        <b-row v-if="results['Files'].length === 0">
          <b-col sm="12">
            {{ $t("noHits") }}
          </b-col>
        </b-row>
      </div>
    </b-container>
    <coscine-loading-spinner :isWaitingForResponse="isWaitingForResponse" />
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { ProjectApi, SearchApi } from "@coscine/api-connection";
import { SemanticSearchApi } from "@coscine/api-client";
import { LinkUtil } from "@coscine/app-util";

import { CoscineLoadingSpinner } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

export default Vue.extend({
  name: "Search",
  data() {
    return {
      projectRoles: [] as Array<unknown>,
      responseSemanticSearch: [] as Array<unknown>,
      isOwner: false,
      usersManagementLink: "",
      baseUrl: "",
      results: {
        Projects: [] as Array<unknown>,
        SubProjects: [] as Array<unknown>,
        Resources: [] as Array<unknown>,
        Files: [] as Array<unknown>,
      },
      searchWord: "",
      projectId: "",
      isWaitingForResponse: false,
      projectDisplayName: "",
    };
  },
  props: {
    parentId: String,
  },
  components: {
    CoscineLoadingSpinner,
  },
  created() {
    this.baseUrl = (_spPageContextInfo as any).siteAbsoluteUrl;
    this.projectId = this.getProjectId();
    this.searchWord = this.getSearchQuery();
    if (this.projectId !== "") {
      ProjectApi.getProjectInformation(this.projectId, (response: any) => {
        this.projectDisplayName = response.data.displayName;
      });
    }
    this.search();
  },
  methods: {
    getProjectId() {
      const id = new URL(window.location.href).searchParams.get("project_id");
      return id !== null ? id : "";
    },
    getSearchQuery() {
      const query = new URL(window.location.href).searchParams.get("query");
      return query !== null ? decodeURIComponent(query) : "";
    },
    getExternalProjectLink(slug = "", page = "Home", queryParams: {} = {}) {
      return LinkUtil.getExternalProjectLink(slug, page, queryParams);
    },
    async search() {
      this.isWaitingForResponse = true;
      const url = new URL(window.location.href);
      url.searchParams.set("project_id", this.projectId);
      url.searchParams.set("query", encodeURIComponent(this.searchWord));
      window.history.replaceState(null, "Search", url.toString());
      
      if (this.searchWord !== "") {
        const responseSemanticSearch =
            await SemanticSearchApi.semanticSearchSearch(this.searchWord);
        this.displayResults({}, responseSemanticSearch);
        
        if (this.projectId === "") {
          SearchApi.getSearchResults(this.searchWord, (response: any) => {
            this.displayResults(response, {});
          });
        }
        else{
          SearchApi.getSearchResultsForProject(
            this.projectId,
            this.searchWord,
            (response: any) => {
              this.displayResults(response, {});
          });
        }
      } else {        
        this.isWaitingForResponse = false;
      }
    },
    displayResults(response: any, responseSemanticSearch: any) {
      if (Object.keys(responseSemanticSearch).length === 0) {
        this.results.Projects.length = 0;
        this.results.SubProjects.length = 0;
        this.results.Resources.length = 0;
    
        for (const datum of response.data.Projects) {
          this.results.Projects.push({
            id: datum.Id,
            displayName: datum.DisplayName,
            slug: datum.Slug,
          });
        }
        for (const datum of response.data.SubProjects) {
          this.results.SubProjects.push({
            id: datum.Id,
            displayName: datum.DisplayName,
            slug: datum.Slug,
          });
        }
        for (const datum of response.data.Resources) {
          this.results.Resources.push({
            id: datum.Id,
            displayName: datum.DisplayName,
            projectId: datum.ProjectId,
            slug: datum.Slug,
          });
        }
      } else if (Object.keys(response).length === 0) {
        this.results.Files.length = 0;
        for (const datum of responseSemanticSearch.data) {
          ProjectApi.getProjectInformation(
            datum.project.substring(
              datum.project.lastIndexOf("/") + 1,
              datum.project.length
            ),
            (resp: any) => {
              const parentProjectSlug = resp.data.slug;
              this.results.Files.push({
                id: datum.graphName.substring(
                  datum.graphName.lastIndexOf("/") + 1,
                  datum.graphName.indexOf("@")
                ),
                displayName: decodeURIComponent(
                  datum.graphName.split("@path=%2F")[1]
                ),
                slug: parentProjectSlug,
              });
            },
            (error: any) => {
              this.results.Files.push({
                id: datum.graphName.substring(
                  datum.graphName.lastIndexOf("/") + 1,
                  datum.graphName.indexOf("@")
                ),
                displayName: decodeURIComponent(
                  datum.graphName.split("@path=%2F")[1]
                ),
              });
            }
          );
        }
      }
      this.isWaitingForResponse = false;
      this.$forceUpdate();
    },
  },
});
</script>

<style>
#search {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}
#search h4 {
  color: #000;
  font-family: "Avenir", Helvetica, Arial, sans-serif;
}
#search-field {
  display: none !important;
}
</style>

<style scoped>
#startSearchButton {
  margin: 0;
}
#search .row {
  text-align: left;
}
#search .row h5 {
  margin-left: 15px;
  margin-top: 10px;
}
#search .input-group {
  margin-left: 15px;
  margin-right: 15px;
}
</style>
